import argparse
from core.log import logger, log_func_progress
from core.evaluation import paper_figures_eval
from core.draw import com_ev_draw, method_draw, dyn_network_draw,  draw_utils, adhoc_draw, paper_figures_draw

@log_func_progress
def main():
    parser = argparse.ArgumentParser(description="A script for ad-hoc experimentation")
    args = parser.parse_args()

    # Produce evaluations for paper
    paper_figures_eval.compute_stats_significance_of_improvement()
    paper_figures_eval.compute_rankings()

    # Produce all figures for paper
    # paper_figures_draw.draw_methods_parameters_figures()
    paper_figures_draw.draw_synthetic_bar_plots()
    # paper_figures_draw.draw_synthetic_scatter_plots()
    paper_figures_draw.draw_rankings_figures()
    #paper_figures_draw.draw_real_world_figures()
    #paper_figures_draw.draw_real_world_cscd_figures()
    # paper_figures_draw.draw_real_world_changepoints_figures()



if __name__ == '__main__':
    main()