from .avg_snapshot_partition_similarity import AvgSnapshotPartitionSimilarity
from .global_partition_similarity import GlobalPartitionSimilarity
from .seg_similarity import AvgSegSimilarity
from ..utils import parse_parentheses

def create_com_evs_similarity_method_by_id(scoring_method_id):
    values = parse_parentheses(scoring_method_id)
    return create_com_evs_similarity_method_by_values(values)

def create_com_evs_similarity_method_by_values(values):
    if values[0] == AvgSnapshotPartitionSimilarity.get_id_prefix():
        return AvgSnapshotPartitionSimilarity(
            partition_similarity_metric=values[1]
        )
    elif values[0] == AvgSegSimilarity.get_id_prefix():
        return AvgSegSimilarity(
            partition_similarity_metric=values[1]
        )
    elif values[0] == GlobalPartitionSimilarity.get_id_prefix():
        return GlobalPartitionSimilarity(
            partition_similarity_metric=values[1]
        )
    raise Exception("Unknown community evolutions similarity method id: %s" % values)

def get_com_evs_similarity_title(scoring_method_id):
    values = parse_parentheses(scoring_method_id)
    return get_com_evs_similarity_title_by_values(values)

def get_com_evs_similarity_class_by_prefix(prefix):
    if prefix == AvgSnapshotPartitionSimilarity.get_id_prefix():
        return AvgSnapshotPartitionSimilarity
    elif prefix == AvgSegSimilarity.get_id_prefix():
        return AvgSegSimilarity
    elif prefix == GlobalPartitionSimilarity.get_id_prefix():
        return GlobalPartitionSimilarity
    raise Exception("Unknown community evolutions similarity method prefix: %s" % prefix)

def get_com_evs_similarity_title_by_values(values):
    return get_com_evs_similarity_class_by_prefix(values[0]).get_com_evs_similarity_method_title(values)