import preprocess_utils
from .. import settings
import shutil
import os

def create_dynamic_network():
    delta_t = '1year'
    threshold = 1
    network_sub_name = '%s_%s' % (delta_t, threshold)
    network_id = 'trade/' + network_sub_name
    network_dir = settings.NETWORKS_BASE_DIR + network_id + '/'

    file_list = []
    with open(settings.NETWORKS_RAW_DATA_DIR + 'trade/trade/tradefiles.dat','r') as infile:
        for line in infile.readlines():
            file_list.append(line.strip())

    if not os.path.exists(network_dir + 'snapshots/'):
        os.makedirs(network_dir + 'snapshots/')

    snapshots_names = []
    for f in file_list:
        y = f.replace('trade_','').replace('.pairs', '')
        shutil.copyfile(settings.NETWORKS_RAW_DATA_DIR + 'trade/trade/' + f, network_dir + 'snapshots/' + y + '.txt')
        snapshots_names.append(y)

    # save ordered snapshots names
    preprocess_utils.save_snapshots_names_ordered(
        output_dir=network_dir,
        snapshots_names=snapshots_names,
    )

    # save node labels
    nodes_labels = {}
    with open(settings.NETWORKS_RAW_DATA_DIR + 'trade/trade/names.lut','r') as infile:
        for line in infile.readlines():
            values = line.strip().split('\t')
            nodes_labels[values[0]] = values[1]

    preprocess_utils.save_node_labels(network_dir, nodes_labels)

    # save description
    with open(settings.NETWORKS_BASE_DIR + network_id + '/description.txt', 'wb') as outfile:
        outfile.write(
            "This is Trade contact network."
        )

