import re
from compare_methods_external_criteria_report_utils import create_report_evaluation_external_criteria
from compare_methods_against_other_report_utils import create_report_evaluation_against_other
from ..evaluation import method_eval
from ..evaluation import method_eval_across_networks

def create_compare_methods_by_regex_report(dynamic_network, method_id_regex, **kwargs):
    regex=re.compile(method_id_regex)
    comparison_methods_key = method_id_regex.replace('\\','')
    methods_ids_list = [m for m in dynamic_network.get_computed_methods_ids_list() if regex.search(m)]
    create_compare_methods_report(
        networks_ids=[dynamic_network.get_id()],
        methods_ids=[methods_ids_list],
        comparison_methods_key=comparison_methods_key,
        **kwargs
    )

def create_compare_methods_report(networks_ids, methods_ids, **kwargs):

    # create the required images, as necessary
    for n_id in networks_ids:
        method_eval.compare_methods(
            methods_ids=methods_ids,
            network_id=n_id,
            overwrite=kwargs.get('overwrite', False),
        )
    # across network comparison evaluation
    # e.g., to get results with avg/std across networks
    if len(networks_ids) > 1:
        method_eval_across_networks.evaluate_methods_across_networks(
            methods_ids=methods_ids,
            networks_ids=networks_ids,
            overwrite=kwargs.get('overwrite', False)
        )

    for func in [
        create_report_evaluation_external_criteria,
        create_report_evaluation_against_other,
    ]:
        func(
            methods_ids=methods_ids,
            networks_ids=networks_ids,
            **kwargs
        )