
#  Method to score community evolution for a dynamic network
class ScoringMethod(object):

    def get_id(self):
        raise NotImplementedError()

    def __str__(self):
        return self.get_id()

    @staticmethod
    def get_id_prefix():
        raise NotImplementedError()

    def get_limits(self):
        raise NotImplementedError()

    def evaluate(self, networks_list, segments_partitions, changepoints):
        raise NotImplementedError()

    def evaluate_community_evolution(self, community_evolution, dynamic_network=None):
        return self.evaluate(
            networks_list=(dynamic_network or community_evolution.get_dynamic_network()).get_snapshots(),
            segments_partitions=community_evolution.get_segments_partitions(),
            changepoints=community_evolution.get_changepoints(),
        )

    def evaluate_method(self, method, dynamic_network=None):
        return self.evaluate_community_evolution(
            community_evolution=method.get_community_evolution(),
            dynamic_network=dynamic_network
        )

