import argparse
from core.log import logger, log_func_progress
from core.community_evolution_generator.generator_utils import (
    create_synthetic_network_evolution_by_id,
)
from core.utils import parse_user_args_string_into_values_list

@log_func_progress
def main():
    parser = argparse.ArgumentParser(description="Create synthetic network evolution")
    parser.add_argument('synthetic_network_id', help="Synthetic network id")
    args = parser.parse_args()

    synthetic_network_id_list = parse_user_args_string_into_values_list(args.synthetic_network_id)

    for i_s, synthetic_network_id in enumerate(synthetic_network_id_list):
        logger.info(
            "{i_s}/{n_s}. Creating synthetic evolution for {synthetic_network_id}...".format(
                i_s=i_s+1,
                n_s=len(synthetic_network_id_list),
                synthetic_network_id=synthetic_network_id,
            )
        )
        sne = create_synthetic_network_evolution_by_id(synthetic_network_id)
        sne.save()

if __name__ == '__main__':
    main()